/*
 * Star Fleet Empire
 * アプリケーションメインクラス
 * 
 * $Id: stars.js,v 1.28 2006/03/24 00:23:17 shio Exp $
 */

BASE_VERSION = "0.60";
DIRECT_CONSOLE = false;
BLACK_MODE=true;
UCHUJU_RITSU=100;
TEST_MODE=false;
WIDTH=25;
HEIGHT=25;
RATE=10;

// 配列クラスの拡張 : ランダムに返す
Array.prototype.randomize = function() {
    var result = new Array();
    for (var i = 0; i < this.length; i++) {
        var rest = this.length - i;
        var rnd = dropDice(rest);
        var ix = -1;
        for (j = 0; j <= rnd; j++) {
            ix += 1;
            while (result[ix]) {
                ix += 1;
            }
        }
        result[ix] = this[i];
    }
    result.length = this.length;
    return result;
}

// 配列クラスの拡張 : 要素を取り除く
Array.prototype.remove = function(ix) {
    var result = new Array();
    for (var i = 0; i < this.length; i++) {
        if (ix != i) {
            result.push(this[i]);
        }
    }

    return result;
}

// 配列クラスの拡張 : 含まれているかどうかを返す
Array.prototype.contains = function(obj) {
    for (var i = 0; i < this.length; i++) {
        if (this[i]  == obj) {
            return true;
         }
     }
    return false;
}

function keys(obj) {
    var result = new Array();
    for (var k in obj) {
        result.push(k);
     }
    return result;
}

 // ダイスを振る - Dashboard がいつも同じ乱数を返すのでミリ秒を足す
function dropDice(mensu) {
    var result = parseInt(Math.random() * mensu);
    result += (new Date()).getTime();
    result %= mensu;

    return result;
}

// 画面オープン時の処理
function onloadBody(body) {
    var func = function() {
        var width = window.innerWidth;
        var height = window.innerHeight;
        var map = document.getElementById("map");
        if (width) {
            map.style.width = (width - 170) + "px";
        }
        var tdmap = document.getElementById("tdmap");
        if (width) {
            tdmap.style.width = (width - 170) + "px";
        }
        var console = document.getElementById("console");
        if (height) {
            var consoleheight = Math.max( (height - 540), 100)
            console.style.height = consoleheight + "px";
            var mapheight = height - consoleheight - 50
            map.style.height =  mapheight + "px";
            var side = document.getElementById("side");
            side.style.height = mapheight + "px";
        }
    }
    app.infoIcon
            = new OpacityIcon(document.getElementById("ibutton"), "app.infoIcon");
    var board = document.getElementById("mainboard");
    this.init();
    if (window.widget) {
        if (isExistFile("savegame/00000.savegame")) {
        clickXmlInOut('xmlInOut');
        loadFile("savegame/00000.savegame");
        return;
    }
    }
    selectGame();
}

// Stars! アプリケーションオブジェクト
function Stars() {
    this.empireList = null;

    this.init = function() {
        this.MAP_FONT_STYLE = "font-size: 10px; text-align: center; width: 14px; height: 14px;";
        this.width = WIDTH;
        this.height = HEIGHT;
        this.turn = 1;
        this.turnPlayer = -1;
        this.commandList = new Array();
        this.settlerCmdList = new Array();
        this.subWinData = new SubWinData();
        this.curMsgList = new Array();
        this.consoleList = new Array();
        this.settlerMap = new Object();
        this.selectMode = false;
        this.selectLoc = "";
        this.selectRange = 0;
        app.spaceMap = new Object();    // 宇宙地図
        app.uchuju = new Uchuju(UCHUJU_RITSU); // 宇宙怪獣管理

        for (var row = 0; row < this.height; row++) {
            for (var col = 0; col < this.width; col++) {
                var lk = makeLocationKey(row, col);
                this.spaceMap[lk] = false;
            }
        }

        this.disableButtonArea();
        this.disableRestartButton();
    }

    // 地図作製処理
    this.createMap = function() {
        setup();

        this.userAgent = empireList[0].ai;

        this.userAgent.findUndplList();
        this.curMsgList = new Array();

        this.enableButtonArea();
    }

    // 選択モード開始
    this.startSelectMode = function(loc, range) {
        this.selectMode = true;
        this.selectLoc = loc;
        this.selectRange = range;
        var div_map = document.getElementById("map");
        div_map.innerHTML = this.dispMap();
    }

    // 選択モード解除
    this.finishSelectMode = function() {
        this.selectMode = false;
        var div_map = document.getElementById("map");
        div_map.innerHTML = this.dispMap();
    }

    /**
     * 地図を画面に表示する。
     * ユーザーターンの場合はターンプレイヤーの所有惑星にリンクを張る
     */
    this.dispMap = function() {
//        var eid = this.turnPlayer + 1;
        var eid = 1;
//        var turnEmpire = this.empireList[this.turnPlayer];
        var turnEmpire = this.empireList[0];
        
        // HTMLに配置する
        var result = '<table class="space_map" id="space_map" width="'
                + this.width * 16 + '">\n';
        for (var row = 0; row < this.height; row++) {
            result += '<tr>';
            for (var col = 0; col < this.width; col++) {
                var lk = makeLocationKey(row, col);
                var bkcolor = "#222233";
                var planetimg = "planet2.png";
                if (isIE() ) {
                    planetimg = "planet2.gif";
                    if (turnEmpire.visibleList[lk]) {
                        bkcolor = "#000044";
                        planetimg = "planet1.gif";
                    }
                } else if (turnEmpire.visibleList[lk]) {
                    bkcolor = "#000044";
                    planetimg = "planet1.png";
                }
                if (BLACK_MODE && ( (! turnEmpire) || ! turnEmpire.isVisible(lk) ) ) {
                    if ( (this.selectMode)
                        && (calDistance(lk, this.selectLoc) <= this.selectRange)) {
                        result += '<td id="' + lk + '" style="background-color: #777777;font-size: 10px;">&nbsp;&nbsp;</td>';
                    } else {
                        result += '<td id="' + lk + '" class="black" style="font-size: 10px;">&nbsp;&nbsp;</td>';
                    }
                    continue;
                }
                var uunit = this.uchuju.isUchujuLoc(lk);
                if (uunit) {
                    result += '<td id="' + lk + '" class="uchuju"';
                    result += ' onmouseover="dispTips(this, event);"'
                    result += ' onmouseout="clearTips(this);"'
                    result += 'title="宇宙怪獣 ' + uunit.getTitle() + '" '
                    result += ' style="background-color' + bkcolor + '">';
                    result += '<img src="uchuju.png" alt="宇宙怪獣"/>';
                } else if (settlerMap[lk] >= 0) {
                   var e = this.empireList[settlerMap[lk]];
                    var title = e.name + '移民船団 ';
                    if (this.spaceMap[lk]) {
                        var p = this.starList[lk];
                        title += "&amp; " + p.titleMsg();
                    }
                    result += '<td id="' + lk + '" class="settler"';
                    result += ' onmouseover="dispTips(this, event);"'
                    result += ' onmouseout="clearTips(this);"'
                    result += 'title="' + title + '" ';
                    result += ' style="' + this.MAP_FONT_STYLE + '">';
                    var settlerimg = (isIE()) ? "settler.gif" : "settler.png";
                    if (this.selectMode) {
                        result += '<div style="background-color: ' + e.color + ';">';
                        result += '<img src="' + settlerimg + '" alt="移民船団">';
                        result += '</div>';
                    } else if (e.id == eid) {
                        result += '<div style="background-color: ' + e.color + ';">';
                        result += "<img src='" + settlerimg + "' alt='移民船団' onclick='clickPlanet(\"" + lk + "\");'/>";
                        result += '</div>';
                    } else {
                        result += '<div style="background-color: ' + e.color + ';">';
                        result += "<img src='" + settlerimg + "' alt='移民船団'/>";
                        result += '</div>';
                    }
                } else if (this.spaceMap[lk]) {
                    var p = this.starList[lk];
                    var pcolor = "#ffff77";
                    if (p.ctl) {
                        pcolor = p.ctl.color;
                    }
                    result += '<td id="' + lk + '" ';
                    result += 'title="' + p.titleMsg() + '" ';
                    result += ' onmouseover="dispTips(this, event);"'
                    result += ' onmouseout="clearTips(this);"'
                    result += 'style="background-color: ' + pcolor + ';';
                    result += this.MAP_FONT_STYLE + '"';
                    result += '>';
                    if ((!this.selectMode) && p.ctl && (eid == p.ctl.id) ) {
                        result += "<img onclick='clickPlanet(\""
                                    + p.loc + "\");' ";
                        result += ' src="' + planetimg + '" ';
                        result += '/>'
                    } else {
                        result += "<img ";
                        result += ' src="' + planetimg + '" ';
                        result += '/>'
                    }
                } else {
                    if ( (this.selectMode)
                        && (calDistance(lk, this.selectLoc) <= this.selectRange)) {
                        result += '<td id="' + lk + '" ';
                        result += 'style="background-color: #aaaacc;';
                        result += this.MAP_FONT_STYLE + '"';
                        result += '>';
                        result += '<img src="space.gif" alt="space"';
                        result += ' onclick="clickSelectLoc(\'';
                        result += lk + '\');" ';
                        result += '/>';
                    } else {
                        result += '<td id="' + lk + '" ';
                        result += 'style="background-color: ' + bkcolor + ';';
                        result += this.MAP_FONT_STYLE + '"';
                        result += '>';
                        result += '<img src="space.gif" alt="space"/>';
                    }
                }
                result += '</td>';
            }
            result += '</tr>\n';
        }

        result += '</table>\n';

        return result;
    }
    
    // 移民船団のHashMapを作成する
    this.makeSettlerMap = function() {
        var map = new Object();
        for (var eix = 0; eix < this.empireList.length; eix++) {
            var e = this.empireList[eix];
            for (var ix = 0; ix < e.settlerList.length; ix++) {
                var loc = e.settlerList[ix];
                map[loc] = eix;
            }
        }
        return map;
    }

    // データの表示
   this.dispData = function() {
       var result = "";
        var e = this.empireList[0];
    
        result += '<div style="background-color : ' + e.color + '">';
        result += '<table id="datatable">';
        result += '<tr><td>';
        result += e.name + ":";
        result += "<span class='item'>人</span>" + e.totalDpl();
        result += "<span class='item'>経</span>" + e.totalEcn();
        result += "<span class='item'>探</span>" + e.fnd;
        result += "<span class='item'>航</span>" + e.nvg;
        result += "<span class='item'>軍</span>" + e.mlt;
        result += "<span class='item'>金</span>" + e.trs;
        result += "<span class='item'>艦</span>" + e.countFleet();
        result += '</td></tr>';
        result += '</table>';
        result += "</div>";
       return result;
    }

    // ゲーム実行
    this.startGame = function() {
        if (app.selectMode) {
            app.finishSelectMode();
            cancelSCmd();
        }
        this.disableButtonArea();
        this.progressGame();
    }

    this.enableButtonArea = function() {
        var elm = document.getElementById("buttonArea");
        elm.style.display = "block";
//        if (isKonqueror() ) {
//            document.getElementById("xmlInOut").style.display = "none";
//        } else {
            document.getElementById("xmlInOut").style.background = "#7777cc";
//        }
    }

    this.disableButtonArea = function() {
        var elm = document.getElementById("buttonArea");
        elm.style.display = "none";
    }

    this.dispMapAndData = function() {
        var div_map = document.getElementById("map");
        var div_data = document.getElementById("data");
        div_map.innerHTML = this.dispMap();
        div_data.innerHTML = this.dispData();
    }

    this.dispRestartButton = function() {
        var elm = document.getElementById("restartButtonArea");
        elm.style.display = "inline";
    }

    this.disableRestartButton = function() {
        var elm = document.getElementById("restartButtonArea");
        elm.style.display = "none";
    }

    this.isGameFinished = false;
    // ゲームの進行
    this.progressGame = function() {
        if (this.isGameFinished) {
            BLACK_MODE = false;
            alert("すでにゲームは終了しています");
            clickDispPoints();
            this.dispRestartButton();
            return;
        }
        this.turnPlayer += 1;
        if (this.turnPlayer >= this.empireList.length) {
            this.turnPlayer = 0;
            this.updateFleetByTurn();
            this.executeCommandList();
            this.executeKaisanFleet();
            this.executeDevelopTec();
            this.turn += 1;
            saveFile(0);
        }
        if  (this.turnPlayer == 0) {
            if (this.countUnctlPlanet() == 0) {
                this.isGameFinished = true;
                BLACK_MODE = false;
                printConsole(this.userAgent.empire.id, "未開拓の星がなくなりました。ゲーム終了です。");
                this.afterMsgFunc = this.finishGame;
                dispAllMsg(this.finishGame);
                return;
            }
            printConsoleFunc("第" + turn + "ターンを開始します");
            this.commandList = new Array();
            this.settlerCmdList = new Array();
            this.incPop();                 // 人口増加
            this.income();                 // 収税
            this.uchuju.clearZero();
            this.uchuju.createUchuju();
            this.settlerMap = this.makeSettlerMap();
            this.uchuju.doActionAll();
            this.settlerMap = this.makeSettlerMap();
        }
        var ix = this.turnPlayer
        var e = this.empireList[ix];
        if (e.user_mode) {
            this.fleetCost(ix);
            this.userAgent = e.ai;
            printConsole(e.id, e.name + "の手番です");
            this.subWinData.init();
            this.userAgent.empire.tmp_trs = this.userAgent.empire.trs;
            this.dispMapAndData();
            this.afterMsgFunc = this.enableButtonArea;
            dispAllMsg();
            outputConsole();
            return;
        }
        this.fleetCost(ix);
        e.ai.thinkSettlers();
        e.ai.thinkPlanets();
        e.ai.thinkTec();
        setTimeout("app.progressGame()", 100);
    }

    this.updateFleetByTurn = function() {
        for (var ix = 0; ix < this.empireList.length; ix++) {
            var e = this.empireList[ix];
            e.updateFleetByTurn(ix);
        }
    }

    this.finishGame = function() {
        this.disableButtonArea();
        this.dispMapAndData();
        clickDispPoints();
        this.dispRestartButton();
    }

    // 科学技術を発展させる
    this.executeDevelopTec = function() {
        for (var ix = 0; ix < this.empireList.length; ix++) {
            var e = this.empireList[ix];
            e.ai.developTec(ix);
        }
    }

    // 人口増加
    this.incPop = function() {
        for (var lk in this.starList) {
        var p = starList[lk];
        if (!(p.dpl))  {
            continue;
          }
        p.inc_p += p.dpl * 1;
        if (p.inc_p >= 100) {
            if (p.dpl == 9) {
                p.inc_p = 99;
            } else {
                    p.inc_p -= 100;
                p.dpl += 1;
printConsole(p.ctl.id, "人口増加 : " + p.name + "(" + p.dpl + ")");
                }
            }
        }
    }

    // 収税
    this.income = function() {
        this.trade = Trade(this.empireList);

        for (var ix = 0; ix < this.empireList.length; ix++) {
            var e = this.empireList[ix];
            e.trs += e.totalEcn(this.starList);
            e.trs += this.trade.tList[ix].trade;
            e.tmp_trs = e.trs;
            if (this.trade.tList[ix].trade != 0) {
printConsole(e.id, e.name + "の貿易収支" + this.trade.tList[ix].trade);
            }
        }
    }

    // 艦隊維持費の支払い
    this.fleetCost = function(ix) {
        var e = this.empireList[ix];
        var c = e.countFleet() * FLEET_MENT_COST;
        if (c > 0) {
            printConsole(e.id, e.name + "の艦隊維持費" + c);
            e.trs -= c;
        }
        c = e.settlerList.length * SETTLER_MENT_COST;
        if (c > 0) {
            printConsole(e.id, e.name + "の移民船団維持費" + c);
            e.trs -= c;
        }
    }

    // 星の有無判定(存在率)
    this.desideStar = function(rate) {
        rnd = dropDice(100);
        if (rnd < rate) {
            return true;
        } else {
            return false;
        }
    }

    // さいころを振る(面数)
    this.rollDice = dropDice;

    // となりのマスのリストを取り出す
    this.ajustList = function(loc) {
        var rc = loc.substr(1).split("c");
        var r = rc[0];
        var c = rc[1];
        var result = new Array();

        var x;
        var y;

        c = c - 0;
        r = r - 0;
        x = c - 1;
        y = r;
        if (x > 0) {
           result.push(makeLocationKey(y, x));
        }
        x = c;
        y = r - 1;
        if (y > 0) {
          result.push(makeLocationKey(y, x));
        }
        x = c;
        y = r + 1;
        if (y < this.height) {
           result.push(makeLocationKey(y, x));
        }
        x = c + 1;
        y = r;
        if (x < this.width) {
           result.push(makeLocationKey(y, x));
        }

        return result;
    }

    // 斜めのマスのリストを取り出す
    this.obliqueList = function(loc) {
        var rc = loc.substr(1).split("c");
        var r = rc[0];
        var c = rc[1];
        var result = new Array();

        c = c - 0;
        r = r - 0;
        var x;
        var y;

        x = c - 1;
        y = r - 1;
        if ( (x > 0) && (y > 0) ) {
            result.push(makeLocationKey(y, x));
        }

        x = c - 1;
        y = r + 1;
        if ( (x > 0) && (y < this.height) ) {
            result.push(makeLocationKey(y, x));
        }

        x = c + 1;
        y = r - 1;
        if ( (x < this.width) && (y > 0) ) {
            result.push(makeLocationKey(y, x));
        }

        x = c + 1;
        y = r + 1;
        if ( (x < this.width) && (y < this.height) ) {
            result.push(makeLocationKey(y, x));
        }

        return result;
    }

    // コマンド実行
    this.executeCommandList = function() {
        // 移民船団のコマンドを実行する
        var list = this.settlerCmdList.randomize();
        for (var i = 0; i < list.length; i++) {
            list[i].cmdExecute();
        }

        // 惑星コマンドを実行する
        list = this.commandList.randomize();
        for (var i = 0; i < list.length; i++) {
           list[i].cmdExecute();
        }

    }

    // 艦隊の解散を実行する
    this.executeKaisanFleet = function() {
        for (var ix = 0; ix < this.empireList.length; ix++) {
            this.empireList[ix].executeKaisanList();
        }
    }

    /**
     * コマンドリストから惑星IDに合致するコマンドを返す
     */
    this.getCmdByPlanetId = function(pid) {
        for (var i = 0 ; i < this.commandList.length; i++) {
            var cmd = this.commandList[i];
            if ( (cmd) && (cmd.planet) && (cmd.planet.id == pid) ) {
                return cmd;
            }
        }

        return null;
    }

    this.setCmdByPlanetId = function(pid, cmd) {
        for (var i = 0 ; i < this.commandList.length; i++) {
            var orgcmd = this.commandList[i];
            if ( (orgcmd) && (orgcmd.planet) && (orgcmd.planet.id == pid) ) {
                if (cmd.id) {
                    this.commandList[i] = cmd;
                } else {
                    this.commandList = this.commandList.remove(i);
                }
                return;
            }
        }
        if (cmd.id) {
            this.commandList.push(cmd);
        }
    }

    this.getSettlerCmd = function(loc) {
        for (var i = 0 ; i < this.settlerCmdList.length; i++) {
            var scmd = this.settlerCmdList[i];
            if (scmd.fromloc == loc) {
                return scmd;
            }
        }

        return new CmdNothing();
    }

    this.setSettlerCmd = function(loc, scmd) {
        for (var i = 0 ; i < this.settlerCmdList.length; i++) {
            var orgcmd = this.settlerCmdList[i];
            if ( (orgcmd) && (orgcmd.fromloc == loc) ) {
                if (scmd.id) {
                    this.settlerCmdList[i] = scmd;
                } else {
                    this.settlerCmdList = this.settlerCmdList.remove(i);
                }
                return;
            }
        }
        if (scmd.id) {
            this.settlerCmdList.push(scmd);
        }
    }
                
    // 未開拓の星の数をカウントする
    this.countUnctlPlanet = function() {
        var result = 0;
        for (var lk in this.starList) {
             var p = this.starList[lk];
             if (p.dpl <= 0) {
                result++;
             }
        }

        return result;
    }

    this.onmouseover = function(id) {
        var elm = document.getElementById(id);
        if (elm) {
            elm.style.backgroundColor = "#ccccff";
        }
    }

    this.onmouseout = function(id) {
        var elm = document.getElementById(id);
        if (elm) {
            elm.style.backgroundColor = "#7777cc";
        }
    }

    this.findSettlerEmpire = function(loc) {
        for (var eix = 0; eix < this.empireList.length; eix++) {
            var e = this.empireList[eix];
            for (var six = 0; six < e.settlerList.length; six++) {
                if (loc == e.settlerList[six]) {
                    return e;
                }
            }
        }
        return null;
    }

    this.getPlanetById = function(id) {
        for (var lk in this.starList) {
            var p = this.starList[lk];
            if (p.id == id) {
                return p;
            }
        }
        return null;
    }

    this.getLocListFromDistance = function(loc, d) {
        var msg = "from = " + loc + ", d = " + d + "\n";

        var list = new Array();
        var rc = makeXYFromLoc(loc);
        var r1 = rc[0];
        var c1 = rc[1];
        var md = Math.floor(d / 2);
        for (var rd = -md; rd <= +md; rd++) {
            var r2 = r1 + rd;
            if (r2 < 0) {
                continue;
            }
            if (r2 >= this.height) {
                continue;
            }
            var cd = d - (rd * 2);
            var c2 = c1 - cd;
            var loc2 = makeLocationKey(r2, c2);
            if ( (c2 >= 0) && (c2 < this.width) ) {
                msg += loc2 + "\n";
                list.push(loc2);
            }
            var c2 = c1 + cd;
            var loc2 = makeLocationKey(r2, c2);
            if ( (c2 >= 0) && (c2 < this.width) ) {
                msg += loc2 + "\n";
                list.push(loc2);
            }
        }
        return list;
    }

            
    return this;
}

function getPlanetById(id) {
    for (var loc in app.starList) {
        p = app.starList[loc];
        if (p.id == id) {
            return p;
        }
    }
    return null;
}

function dispAllMsg() {
    var e = document.getElementById("msgbox");
    if (app.curMsgList.length > 0) {
        var str = "<table><tr><td>" + app.curMsgList.shift() + "</td></tr></table>";
        e.innerHTML = str;
        e.style.display = "inline";
        setTimeout("dispAllMsg()", 1000);
    } else {
        e.style.display = "none";
        app.afterMsgFunc();
    }
}

function calDistance(lk1, lk2) {
    try {
        var loc1 = makeXYFromLoc(lk1);
        var loc2 = makeXYFromLoc(lk2);

        var rd = Math.abs(loc1[0] - loc2[0]);
        var cd = Math.abs(loc1[1] - loc2[1]);
        var maxd = (rd >= cd) ? rd : cd;
        var mind = (rd < cd) ? rd : cd;

        return maxd * 2 + mind;
    } catch(e) {
        alert("Err in calDistance(" + lk1 + ", " + lk2 + ")" + e);
    }
}

/**
 * lockeyをばらしてx,yにします。
 */
function makeXYFromLoc(loc) {
    var result = loc.substring(1).split("c");
    result[0] = parseInt(result[0]);
    result[1] = parseInt(result[1]);

    return result;
}

function initConsole() {
    for (var i = 0; i < 1000; i++) {
        var obj = new Object();
        obj.str = "";
        obj.eid = null;
        app.consoleList.push(obj);
    }
}

/**
 * コンソールに文字を表示する
 */
function printConsole(eid, str) {
    if (BLACK_MODE) {
        if (app.userAgent && (! app.userAgent.checkDisp(eid)) ) {
            return;
        }
    }
    if (app.userAgent.empire.id == eid) {
        app.curMsgList.push(str);
    }

    printConsoleFunc(str, eid);
}

function printConsoleByLoc(loc, str) {
    if ( (BLACK_MODE) && (! app.userAgent.empire.isVisible(loc) ) ) {
        return;
    }

    printConsoleFunc(str);
}

function printConsoleFunc(str, eid) {
    if (TEST_MODE) {
        app.curMsgList.push(str);
    }
    var obj = new Object();
    obj.str = str;
    obj.eid = eid;
    app.consoleList.push(obj);
    if (app.consoleList.length > 100) {
        app.consoleList.shift();
    }
    if (DIRECT_CONSOLE) {
        outputConsole();
    }
}

function outputConsole() {
    var msg = "<table>";
    for (var i = app.consoleList.length - 1; i >= 0; i--) {
        var color = "#eeeeee";
        var obj = app.consoleList[i];
        if (obj.eid) {
            if (obj.eid == app.userAgent.empire.id) {
                color = "#ffdddd";
            }
        }
        msg += "<tr><td style='color:" + color + ";'>";
        msg += obj.str;
        msg += "</td></tr>";
    }
    var console = document.getElementById("console");
    console.innerHTML = msg;
}

// Location Key の作成 "r0c0"形式
function makeLocationKey(row, col) {
    var result = "r" + row + "c" + col;

    return result;
}

function moveTo(fromloc, toloc, distance) {
    var d = calDistance(fromloc, toloc);
    if (d <= distance) {
        return toloc;
    }
    var l1 = makeXYFromLoc(fromloc);
    var l2 = makeXYFromLoc(toloc);
    var rd = l2[0] - l1[0];
    var cd = l2[1] - l1[1];
    var ard = Math.abs(rd);
    var acd = Math.abs(cd);
    var naname = Math.min(ard, acd);
    var yoko = Math.max(ard, acd) - naname;
    var rest = distance;
    var naname_m = 0;
    if (distance > naname * 3) {
        naname_m = naname;
    } else {
        naname_m = parseInt(distance / 3);
    }
    rest -= naname_m * 3;
    var yoko_m = 0;
    if (rest > yoko * 2) {
        yoko_m = yoko;
    } else {
        yoko_m = parseInt(rest / 2);
    }
    rest -= yoko_m * 2;
    if ( ( (rest % 2) > 0) && ( (yoko - yoko_m) >= 2) && (naname_m > 0) ) {
        naname_m -= 1;
        yoko_m += 2;
        rest -= 1;
    }
    if ( (rest >= 2) && (naname - naname_m > 0) && (yoko - yoko_m == 0) ) {
        yoko_m += 1;
        rest -= 2;
    }

    var r = l1[0];
    var c = l1[1];
    if (rd < 0) {
        r -= naname_m;
        if (ard >= acd) {
            r -= yoko_m;
        }
    } else {
        r += naname_m;
        if (ard >= acd) {
            r += yoko_m;
        }
    }
    if (cd < 0) {
        c -= naname_m;
        if (acd > ard) {
            c -= yoko_m;
        }
    } else {
        c += naname_m;
        if (acd > ard) {
            c += yoko_m;
        }
    }
    var newloc = makeLocationKey(r, c);

    return newloc;
}

var tipstimer = null;
function dispTips(elm, event) {
    if (! event) {
        event = window.event;
    }
    var title = elm.getAttribute("title");
    var tips = document.getElementById("tipsbox");
    var loc = elm.id;
    var rc = makeXYFromLoc(loc);
    tips.style.top = event.clientY - 10 + "px";
    tips.style.left = event.clientX + 10 + "px";
    tips.style.display = "block";
    tips.innerHTML = title;
    if (tipstimer) {
        clearTimeout(tipstimer);
    }
}

function clearTips() {
    tipstimer = setTimeout(clearTipsTimeout, 300);
}

function clearTipsTimeout() {
    var tips = document.getElementById("tipsbox");
    tips.style.display = "none";
    tipstimer = null;
}

function closeConsole() {
    var elm = document.getElementById("consoleWin");
    elm.style.display = "none";
    
}


movingWinInfo.add("consoleWin", 290, 80, "consoleTitle");
movingWinInfo.add("subWindow", 50, 50, "windowTitle");

function clickDispMsgConsole() {
    var imgfile = (isIE()) ? "subwin4.gif" : "subwin4.png";
    document.getElementById("consoleimg").setAttribute("src", imgfile);
    movingWinInfo.consoleWin.disp();
}

function restartGame() {
    BLACK_MODE = true;
    app.init();
    selectGame();
    app.dispOmote();
}
