/**
  * Star Fleet Empire
  * DashboardWidget関連処理
  * 
  * $Id: widget.js,v 1.5 2006/03/12 01:54:47 shio Exp $
  */

// iアイコン上にマウスカーソルが来た時のイベント処理
function infoover(id) {
    document.getElementById(id).style.display = "block";
}

// iアイコン上からマウスカーソルが離れた時のイベント処理
function infoout(id) {
    document.getElementById(id).style.display = "none";
}

// bodyにマウスが乗った時のイベント処理
app.overBody = function() {
    if (this.infoIcon) {
        this.infoIcon.start(true);
    }
}

// マウスカーソルがbodyから出た時のイベント処理
app.outBody = function() {
    if (this.infoIcon) {
        this.infoIcon.start(false);
    }
}

// 表面を表示する。
app.dispOmote = function() {
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }
    this.pause = false;
    document.getElementById("ura").style.display = "none";
    document.getElementById("omote").style.display = "block";
    if (window.widget) {
        setTimeout("widget.performTransition();", 0);
    }
}

// 裏面を表示する
app.dispUra = function() {
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }
    if (isIE() ) {
        document.getElementById("done").setAttribute("src", "done.gif");
    }
    this.pause = true;
    document.getElementById("omote").style.display = "none";
    document.getElementById("ura").style.display = "block";
    infoout("ibuttonback");
    if (window.widget) {
        setTimeout("widget.performTransition();", 0);
    }
}

// widget表示時のイベント処理
function onshow() {
}

// widget非表示時のイベント処理
function onhide() {
}

function initialize() {
}

widgetLogger = new WidgetLogger();

function WidgetLogger() {
    if (window.widget) {
        widget.system("/bin/echo > /tmp/widget.log", null);
    }
    
    this.printHandler = function() {
    }
    
    this.print = function(str) {
        if (window.widget) {
            var cmd = widget.system(
                    "/bin/cat >> /tmp/widget.log"
                    , this.printHandler);
            cmd.write(str);
            cmd.write(unescape("%0A"));
            cmd.close();
        }
    }
}

// URLを開く（widgetでブラウザに表示）
function openURL(url) {
    if (window.widget) {
        widget.openURL(url);
    } else {
        window.open(url, "doc");
    }
}

function openFile(fname) {
    if (window.widget) {
        widget.system("/usr/bin/open " + fname, null);
    } else {
        window.open(fname, "doc");
    }
}

// 透明化アイコン(Widgetのiアイコンのようなもの)の管理クラス
function OpacityIcon(elm, path) {
    this.dispmode = true;
    this.opavalue = 0;
    this.elm = elm;
    this.path = path;
    this.timer = null;

    this.timeout = function() {
        if (this.dispmode) {
            if (this.opavalue >= 1) {
                this.timer = null;
                return;
            }
            this.opavalue += 0.1;
        } else {
            if (this.opavalue <= 0) {
                this.timer = null;
                return;
            }
            this.opavalue -= 0.1;
        }
        if (this.opavalue < 0.1) {
            this.elm.style.opacity = 0;
            this.elm.style.display = "none";
        } else {
            if (this.elm.style.display != "block") {
                this.elm.style.display = "block";
            }
            this.elm.style.opacity = this.opavalue;
        }
        this.timer = setTimeout(this.path + ".timeout()", 100);
    }

    this.start = function(dispmode) {
        this.dispmode = dispmode;
        if (this.timer == null) {
            this.timer = setTimeout(this.path + ".timeout()", 100);
        }
    }
}

